package org.artifactory.federation;

import org.artifactory.descriptor.authentication.AuthenticationToken;
import org.artifactory.descriptor.repo.FederatedMember;
import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.repo.RepoDetails;
import org.jetbrains.annotations.NotNull;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * @author Alexei Vainshtein
 */
@Service
public class DefaultFederatedRepoServiceImpl implements FederatedRepoService {

    @Override
    public void createRecreateOrRemoveRemoteMembers(FederatedRepoDescriptor newDescriptor,
            Set<FederatedMember> oldMembers) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public List<FederationReposResponse> getReposFromRemote(List<String> urls, String proxyName) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public List<RepoDetails> getRepos() {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public String getToken(String remoteUrl, String key) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void validate(String key, String clientBaseUrl, long timeFromRequestingServer) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void validateFederationLicenseInstalled() {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void validateRemoteServer(String fullUrl, String proxyName) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void addInconsistentRepoMember(String memberUrl, String repoKey) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void removeRepoFromRemoteMembers(FederatedRepoDescriptor federatedDescriptor) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void saveAuthenticationMasterToken(String tokenId, String tokenType, String scope,
                                               String baseUrl, String exchangeUrl, String accessToken, Long expiresIn) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public Collection<AuthenticationToken> getPairedAuthenticationTokens() {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    public Set<String> getInconsistentRepos(){
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @Override
    public void removeInconsistentRepoMember(String memberUrl) {
        throw new UnsupportedOperationException(getUnsupportedMessage());
    }

    @NotNull
    private String getUnsupportedMessage() {
        return "Unsupported operation: federated";
    }

    @Override
    public void onLicenseLoaded() {

    }

    @Override
    public void onContextCreated() {

    }
}
