package org.artifactory.api.repo;

import lombok.Builder;
import lombok.Getter;
import org.springframework.scheduling.concurrent.ConcurrentTaskExecutor;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.function.Supplier;

/**
 * AsyncWorkQueueCustomExecutor is used to customize the async execution
 *
 * @author shaharz
 */

@Builder
@Getter
public class AsyncWorkQueueCustomExecutor {

    /**
     * suffix for the WorkQueue, to differentiate from the regular WorkQueue
     */
    @Nullable
    private String nameSuffix;
    /**
     * Custom executor to execute the work queue items
     */
    @Nullable
    private ConcurrentTaskExecutor executor;

    @Nullable
    private String repoKey;

    @Nonnull
    private Supplier<Integer> threadsCount;
}
